/*
 * Created on Aug 1, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.impl.broker;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.globus.mds.glue.GLUECERPType;

import org.ggf.schemas.jsdl._2005._06.jsdl.JobDefinition_Type;
import se.umu.jobsubmission.JobPreferences;
import se.umu.jobsubmission.util.Worker;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class EarliestStartWorker extends  Worker {
	
	private static Logger logger = Logger.getLogger(EarliestStartWorker.class); 
	
	private Predictor startTimePredictor; 
	private Predictor runTimePredictor; 
	private Predictor stageInTimePredictor; 
	
	private JobDefinition_Type jobDescription; 
	private JobPreferences preferences; 
	private Map fileSizes; 
	
	public EarliestStartWorker(Object resource, 
    		JobDefinition_Type jobDescription, 
			JobPreferences preferences, 
			Map fileSizes, 
			Predictor startTimePredictor, 
			Predictor runTimePredictor, 
			Predictor stageInTimePredictor) {
		
		super(resource); // Setting workUnit to resource
		
		this.jobDescription = jobDescription; 
		this.preferences = preferences; 
		this.fileSizes = fileSizes; 
		
		this.startTimePredictor = startTimePredictor; 
		this.runTimePredictor = runTimePredictor; 
		this.stageInTimePredictor = stageInTimePredictor; 
		
	}
	
    public void doWork() {
    	
    	int startTime = 0; 
		int runTime = 0; 
		int stageInTime = 0; 
		String resourceName; 
    	// Predict start time for each resource and save times in a list. 
	//	for(int i = 0; i < resources.size(); i++) {
			
		// resource = resources.get(i);     		
		resourceName= ((GLUECERPType)this.workUnit).getCluster(0).getName();     		
		logger.debug("Determining TTD for " + resourceName); 
		
		// Need runTime and stageInTime for startTime, 
		// order is stageInTime, runTime, startTime
		
		// stageInTime, do not predict if user specified 
		// it in job preferences. 
		if(fileSizes != null) {
			stageInTime = this.stageInTimePredictor.predict(jobDescription, 
					this.workUnit, 
					preferences, 
					fileSizes); 
		}    		    		
		
		// runTime: 
		runTime = this.runTimePredictor.predict(jobDescription, 
				this.workUnit, 
				preferences, 
				null);   
		
		// startTime: 
		// pass runTime and stageInTime to startTimePredictor
		Map context = new HashMap(); 
		context.put("runTime", new Integer(runTime)); 
		context.put("stageInTime", new Integer(stageInTime)); 			
		startTime = this.startTimePredictor.predict(jobDescription, 
				this.workUnit, 
				preferences, 
				context);     			
		
		logger.debug("TTD ( = start time) for resource " + startTime); 
		// completionTimes.add(new Integer(startTime)); 
		
		// Store time with resource in result set. 
		RankedResource resource = new RankedResource(
				(GLUECERPType)this.workUnit, 
				startTime); 
		this.resultSet.add(resource); 
    	
    
    }

}
