package se.umu.jobsubmission.impl.dispatcher; 

/**
 * Interface for job dispatcher. Implementations of this interface
 * are responsible for sending the job request to the selected resource. 
 */

public interface Dispatcher {

	
	public final static int DEFAULT_CPU_TIME = 5; // 5 minutes. 
	public final static int DEFAULT_CPU_COUNT = 1; 
    /**
      Resource - description of submission target, e.g., in GLUE format
      jobDescription - Description of job request in native format, e.g. xRSL
      reservation - information about an advande reservation, typically 
                    only the local reservation info is used. 
      clientURL - URL to host from which job is submitted. */
    public Object requestJob(Object resource,   
                             Object jobDescription, 
                             Object reservation, 
                             String clientURL) throws Exception; 


}
