/*
 * Created on Oct 14, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.impl.informationfinder;

import javax.xml.rpc.Stub;

import org.apache.axis.message.addressing.EndpointReferenceType;
import org.globus.axis.util.Util;
import org.globus.gsi.GlobusCredential;
import org.globus.gsi.gssapi.GlobusGSSCredentialImpl;
import org.globus.wsrf.impl.security.authentication.Constants;
import org.globus.wsrf.impl.security.authorization.HostAuthorization;
import org.globus.wsrf.impl.security.descriptor.ClientSecurityDescriptor;
import org.ietf.jgss.GSSCredential;

import org.apache.axis.message.addressing.Address;
import se.umu.wsag.util.JobSubmissionUtils;

import org.oasis.wsrf.properties.WSResourcePropertiesServiceAddressingLocator;
import org.oasis.wsrf.properties.QueryResourceProperties_Element;
import org.oasis.wsrf.properties.QueryResourcePropertiesResponse;
import org.oasis.wsrf.properties.QueryExpressionType;
import org.oasis.wsrf.properties.QueryResourceProperties_PortType;

import org.globus.wsrf.WSRFConstants;

import org.globus.mds.aggregator.types.AggregatorContent;

import org.apache.axis.message.MessageElement;

import org.globus.wsrf.encoding.ObjectDeserializer;

import org.globus.wsrf.utils.AnyHelper;


import org.apache.log4j.Logger;

/**
 * @author tordsson
 * Based on GT4 wsrf-query client 
 */
public class GT4InformationFetcher implements InformationFetcher {
	
	
    static {
        Util.registerTransport(); 
    }

	
	
	private static Logger logger = Logger.getLogger(GT4InformationFetcher.class); 
	
	public String translateURL(String url) {
		return url; 
	}
	
	public Object getInformation(String resourceURL, int timeout) 
		throws Exception {
		
		try {
			
			String dialect = WSRFConstants.XPATH_1_DIALECT;
			String expression = "//*[local-name()='Content']"; 
			
			// Get WSRF-Query stub: 
			
			EndpointReferenceType epr = new EndpointReferenceType();
			epr.setAddress(new Address(resourceURL));

	        WSResourcePropertiesServiceAddressingLocator locator =
	            new WSResourcePropertiesServiceAddressingLocator();

	        QueryExpressionType query = new QueryExpressionType();
	        query.setDialect(dialect);
	        query.setValue(expression);
	            
	        QueryResourceProperties_PortType port =
	        	locator.getQueryResourcePropertiesPort(epr);
	        
	        QueryResourceProperties_Element request = 
	        	new QueryResourceProperties_Element();
	        request.setQueryExpression(query);

	        // Create and configure client security descriptor
			ClientSecurityDescriptor secDesc = new ClientSecurityDescriptor();
			secDesc.setGSITransport(Constants.ENCRYPTION); // Really guessing here... 
			secDesc.setAuthz(HostAuthorization.getInstance()); 
			
			/*
			GlobusCredential globusCredential = 
				JobSubmissionUtils.getDelegatedCredential(); 
			*/
			// Run as stand-alone client. 
			GlobusCredential globusCredential = GlobusCredential.getDefaultCredential(); 
			
			GSSCredential credential = new GlobusGSSCredentialImpl(globusCredential, 
					GSSCredential.INITIATE_AND_ACCEPT); 
			if(credential != null) {
				secDesc.setGSSCredential(credential); 
			}
			
			((Stub) port)._setProperty(Constants.CLIENT_DESCRIPTOR, secDesc);
			
			QueryResourcePropertiesResponse response = 
				port.queryResourceProperties(request);
			MessageElement any[] = response.get_any(); 
			
			System.out.println("We got:"); 
			
		    System.out.println(AnyHelper.toSingleString(response));
		    
		    if(any != null) {
		    	// The next lines gives: 
		    	// org.globus.wsrf.encoding.DeserializationException: 
		    	// Deserialziation failed [Caused by: No deserializer for null]
		    	// Object objs[] = ObjectDeserializer.toObject(any); 
		    	
		    	AggregatorContent content = 
		    		(AggregatorContent) ObjectDeserializer.toObject(any[0], 
		    			AggregatorContent.class);
		    	
		    	System.out.println("We got: " + content); 
		    }
		    else {
		    	System.out.println("Any is null...");
		    }
			
		} catch (Exception e) {
			logger.error("Error fetching information from resource: " + resourceURL); 
		}
		return null; 
	}
	
	public static void main(String args[]) throws Exception {
		new GT4InformationFetcher().getInformation(args[0], 0); 
	}
	
}
