/*
 * Created on Jul 26, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.impl.informationfinder;


import java.util.Calendar;

import org.apache.log4j.Logger;
import org.ggf.schemas.jsdl._2005._06.jsdl.JobDefinition_Type;
import org.globus.mds.glue.GLUECERPType;
import org.globus.mds.glue.StateType;

import EDU.oswego.cs.dl.util.concurrent.ConcurrentReaderHashMap;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class ResourceInformationCache {
	
	private static Logger logger = Logger.getLogger(
			ResourceInformationCache.class); 
	private ConcurrentReaderHashMap map; 
	
	/**
	 * 
	 */
	public ResourceInformationCache() {
		super(); 
		map = new ConcurrentReaderHashMap(); 
	}
	
	public CachedResourceInformation get(Object key) {
		return (CachedResourceInformation) map.get(key); 
	}
	
	public void put(Object key, GLUECERPType info, Calendar timestamp) {
		CachedResourceInformation newInfo = new CachedResourceInformation( 
				timestamp, info); 
		map.put(key, newInfo); 
	}
	
	// Recalculate number of jobs and free CPUs for this resource
	// after submitting a job
	public void update(GLUECERPType info, JobDefinition_Type jobDescription) {		
		
    	// Number of CPUs
    	int numberOfCPUs; 
    	try {
    		/*
    		String CPUPath[] = {"JobDefinition", 
    				"JobDescription", 
					"Application", 
    		        "ProcessCount"};    	
    		Element root = jobDescription.getRootElement(); 
    		Element processCount = JobSubmissionUtils.getElement(root, CPUPath); 
    		try {
    			numberOfCPUs = Integer.parseInt(processCount.getText()); 
    		} catch (NumberFormatException e) {
    			logger.warn("Illegal value (" 
    					+ processCount.getText() 
						+ ") for \"ProcessCount\""); 
    			numberOfCPUs = 1; 
    		}*/
    		numberOfCPUs = (int) jobDescription.getJobDescription().
					getResources().getTotalCPUCount().getExact()[0].get_value();
    	}
    	catch (Exception e) {
    		logger.info("\"ProcessCount\" not specified, assuming 1 CPU");
    		numberOfCPUs = 1; 
    	} 
    	
    	// Decrease number of free CPUs with the number of CPUs used by the job. 
    	StateType state = info.getComputingElement(0).getState(); 
    	int freeCPUs = state.getFreeCPUs(); 
    	// logger.warn("Resource had: " + freeCPUs + " free CPUs"); 
    	if((freeCPUs - numberOfCPUs) > 0)
    		state.setFreeCPUs(freeCPUs - numberOfCPUs); 
    	
    	//logger.warn("Resource now has: " + info.getComputingElement(0).
    	//		getState().getFreeCPUs() + " free CPUs"); 
    	
    	// Add an extra job. 
    	int numberOfJobs = state.getTotalJobs(); 
    	// logger.warn("Resource had " + numberOfJobs + " jobs"); 
    	state.setTotalJobs(numberOfJobs + 1); 
    	//logger.warn("Resource now has " + info.getComputingElement(0).
    	//		getState().getTotalJobs() + " jobs"); 
    	
    	/*
    			(numberOfJobs + 1) + " jobs"); 
    	
    	Enumeration values = map.elements(); 
    	CachedResourceInformation cachedInfo = null; 
    	while(values.hasMoreElements()) {
    		Object value = values.nextElement(); 
    		logger.warn("Value has type: " + value.getClass().getName()); 
    		CachedResourceInformation tmp = (CachedResourceInformation) 
					value; 
    		if(tmp.getInformation().getComputingElement(0).
    				getName().equals(info.getComputingElement(0).getName())) {
    			logger.warn("Found resource"); 
    			cachedInfo = tmp; 
    		}
    		else 
    			logger.warn("Wrong resource"); 
    	}
    	logger.warn("Done searching cache"); 
    	if(cachedInfo == null) {
    		logger.warn("Resource not found in cache!"); 
    	}
    	else {
    		logger.warn("Updating cache"); 
    		cachedInfo.setInformation(info);     		
    	}
    	*/
	}
}
