/*
 * Created on Oct 4, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.client;

import java.io.File;
import java.io.FileInputStream;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.axis.message.MessageElement;
import org.apache.axis.types.NCName;
import org.apache.axis.types.NormalizedString;
import org.apache.axis.types.URI;
import org.ggf.schemas.jsdl._2005._06.jsdl.Application_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.CandidateHosts_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.DataStaging_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.Exact_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.JobDefinition_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.JobDescription_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.JobIdentification_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.RangeValue_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.Resources_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl.SourceTarget_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl_posix.Argument_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl_posix.Environment_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl_posix.FileName_Type;
import org.ggf.schemas.jsdl._2005._06.jsdl_posix.POSIXApplication_Type;
import org.globus.rsl.AbstractRslNode;
import org.globus.rsl.NameOpValue;
import org.globus.rsl.RSLParser;
import org.globus.rsl.RslNode;
import org.globus.rsl.Value;
import org.globus.wsrf.utils.AnyHelper;

import se.umu.jobsubmission.util.JobDescriptionTranslator;
/**
 * @author tordsson
 *
 * An implementation of a translator between xRSL and JSDL, 
 * using the generated JSDL types instead of expressing the 
 * JSDL document using JDOM. 
 * 
 * TODO: Translate 'architecture'...
 * 
 */
public class XRSL2JSDL implements JobDescriptionTranslator  {
	
	
	public void convertAttribute(NameOpValue xrslAttribute, 
			JobDescription_Type jsdl,  
			POSIXApplication_Type posix) throws Exception {
		
		String attributeName = xrslAttribute.getAttribute(); 
		List values = xrslAttribute.getValues(); 
		List stringValues = xrslAttribute.getValuesAsStrings(true); 
			
		if("executable".equalsIgnoreCase(attributeName)) {
			FileName_Type fileName = new FileName_Type();  
			fileName.set_value((String)stringValues.get(0)); 
			posix.setExecutable(fileName); 
		}
		if("stdin".equalsIgnoreCase(attributeName)) {
			FileName_Type fileName = new FileName_Type(); 
			fileName.set_value((String)stringValues.get(0)); 
			posix.setInput(fileName); 			
		}
		if("stdout".equalsIgnoreCase(attributeName)) {
			FileName_Type fileName = new FileName_Type(); 
			fileName.set_value((String)stringValues.get(0)); 
			posix.setOutput(fileName); 			
		}
		if("stderr".equalsIgnoreCase(attributeName)) {
			FileName_Type fileName = new FileName_Type(); 
			fileName.set_value((String)stringValues.get(0)); 
			posix.setError(fileName); 			
		}
		if("arguments".equalsIgnoreCase(attributeName)) {
			Argument_Type arguments[] = new Argument_Type[stringValues.size()];
			for(int i = 0; i < stringValues.size(); i++) {
				Argument_Type argument = new Argument_Type(); 
				NormalizedString argString = new NormalizedString(); 
				argString.setValue((String)stringValues.get(i)); 
				argument.set_value(argString); 
				arguments[i] = argument; 
			}
			posix.setArgument(arguments); 
		}
		if("count".equalsIgnoreCase(attributeName)) {
			Resources_Type resource = jsdl.getResources();
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exactValue[] = new Exact_Type[1]; 
			exactValue[0] = new Exact_Type(); 
			exactValue[0].set_value(new Double((String)stringValues.get(0)).
					doubleValue()); 
			value.setExact(exactValue); 
			resource.setTotalCPUCount(value); 
		}
		// FIXME: does (memory=256) in ARC, mean totally 256 or 256 / job? 
		// At the moment, assuming 256 per job. 
		if("memory".equalsIgnoreCase(attributeName)) {
			Resources_Type resource = jsdl.getResources(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exactValue[] = new Exact_Type[1]; 
			exactValue[0] = new Exact_Type(); 
			String s = (String) stringValues.get(0); 
			Double doubleD = new Double(s); 
			double d = doubleD.doubleValue(); 
			exactValue[0].set_value(d); 
			value.setExact(exactValue); 
			resource.setIndividualPhysicalMemory(value); 
		}
		if("cluster".equalsIgnoreCase(attributeName)) {
			Resources_Type resource = jsdl.getResources(); 
			CandidateHosts_Type hosts = new CandidateHosts_Type(); 
			String hostNames[] = new String[]{(String)stringValues.get(0)}; 
			hosts.setHostName(hostNames); 
			resource.setCandidateHosts(hosts); 
		}
		if("jobName".equalsIgnoreCase(attributeName)) {
			JobIdentification_Type jobID = new JobIdentification_Type(); 
			jobID.setJobName((String)stringValues.get(0));
			jsdl.setJobIdentification(jobID); 
		}
		if("disk".equalsIgnoreCase(attributeName)) {
			Resources_Type resource = jsdl.getResources(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exactValue[] = new Exact_Type[1]; 
			exactValue[0] = new Exact_Type(); 
			exactValue[0].set_value(new Double((String)stringValues.get(0)).
					doubleValue()); 
			value.setExact(exactValue); 			
			resource.setIndividualDiskSpace(value); 
		}
		// Threat both of these the same. However, "gridTime" should 
		// never appear in a xRSL document created by the client plugin...
		if("cpuTime".equalsIgnoreCase(attributeName) 
				|| "gridTime".equalsIgnoreCase(attributeName)) {
			Resources_Type resource = jsdl.getResources(); 
			RangeValue_Type value = new RangeValue_Type(); 
			Exact_Type exactValue[] = new Exact_Type[] {new Exact_Type()};
			int time = Integer.parseInt((String) stringValues.get(0)); 
			time = time * 60; // JSDL expressed time in seconds. 
			exactValue[0].set_value((double) time); 
			value.setExact(exactValue); 
			resource.setIndividualCPUTime(value); 
		}
		// Not that typesafe in classcasts...
		if("environment".equalsIgnoreCase(attributeName)) {
			int size = values.size(); 
			Environment_Type[] environment = new Environment_Type[size]; 
			for(int i = 0; i < size; i++) {
				environment[i] = new Environment_Type(); 
				List env = (List) values.get(i); 
				String envName = ((Value) env.get(0)).getValue(); 
				String envValue = ((Value) env.get(1)).getValue(); 
				NCName name = new NCName(); 
				name.setValue(envName); 
				environment[i].setName(name); 
				environment[i].set_value(envValue);
			}
			posix.setEnvironment(environment); 
		}
		// Not that typesafe in casts. 
		if("inputfiles".equalsIgnoreCase(attributeName) 
				|| "outputfiles".equalsIgnoreCase(attributeName)) {
			
			for(int i = 0; i < values.size(); i++) {
				
				DataStaging_Type newTransfer = new DataStaging_Type(); 
				
				List staging = (List) values.get(i); 
				String localName = ((Value) staging.get(0)).getValue(); 
				newTransfer.setFileName(localName); 
				
				String remoteName = ((Value) staging.get(1)).getValue(); 		
				SourceTarget_Type jsdlRemoteName = new SourceTarget_Type(); 
				try {
					jsdlRemoteName.setURI(new URI(remoteName)); 		
				} catch (Exception e) {
					// We need to pass an URI, 
					// so create one from the filename by adding file://					
					
					// Get complete path to file if "" is specfied. 
					if(remoteName == null || "".equals(remoteName)){
						File f = new File(localName); 
						jsdlRemoteName.setURI(new URI("file://" 
								+ f.getCanonicalPath())); 
					}
					else {
						jsdlRemoteName.setURI(new URI("file://" + remoteName)); 
					}
				}
				
				// Only staging direction separates inputfiles from outputfiles
				if("inputFiles".equalsIgnoreCase(attributeName)) {
					newTransfer.setSource(jsdlRemoteName); 
				}
				else {
					newTransfer.setTarget(jsdlRemoteName); 
				}
				
				DataStaging_Type dataStaging[] = jsdl.getDataStaging(); 
				
				// Add a new DataStaging, or if one already exists, 
				// replace it with one containing the new transfer as well. 
				if(dataStaging == null) {
					dataStaging = new DataStaging_Type[]{newTransfer}; 						
					jsdl.setDataStaging(dataStaging);			
				}
				else {
					int size = dataStaging.length; 
					DataStaging_Type newDataStaging[] = 
						new DataStaging_Type[size + 1]; 
					for(int j = 0; j < size; j++) { 
						newDataStaging[j] = new DataStaging_Type(
								dataStaging[j].getCreationFlag(), 
								dataStaging[j].getDeleteOnTermination(),
								dataStaging[j].getFileName(), 
								dataStaging[j].getFilesystemName(), 
								dataStaging[j].getName(), 
								dataStaging[j].getSource(),
								dataStaging[j].getTarget()); 
					}
					newDataStaging[size] = newTransfer; 
					jsdl.setDataStaging(newDataStaging); 
				}
			}
		}
	}
	
	
	public Object translate(Object xrslJobDescription) throws Exception {
		
		String xrslFileName = (String) xrslJobDescription; 
		FileInputStream is = new FileInputStream(new File(xrslFileName)); 
		RSLParser parser = new RSLParser(is); 
		AbstractRslNode xrslNode = parser.parse();
		
		// Ensure that only one xRSL job is defined. 
		int op = xrslNode.getOperator(); 
		if(op == AbstractRslNode.MULTI) {
			throw new Exception("Multijobs are not supported"); 
		}
		
		// Create jsdl object: 
		JobDefinition_Type jobDefinition = new JobDefinition_Type(); 
		JobDescription_Type jobDescription = new JobDescription_Type(); 
		Application_Type application = new Application_Type(); 
		Resources_Type resource = new Resources_Type(); 
		jobDescription.setResources(resource); 
		
		POSIXApplication_Type posixApplication = new POSIXApplication_Type(); 
		
		// Traverse jsdl and translate each attribute. 
		if(op == AbstractRslNode.AND || op == AbstractRslNode.OR) {
			RslNode n = (RslNode) xrslNode; 
			Map m = n.getRelations(); 
			Iterator it = m.values().iterator(); 
			while(it.hasNext()) 
				convertAttribute((NameOpValue)it.next(), 
						jobDescription, 
						posixApplication); 
		}
		
		// Connect jsdl object. 
		MessageElement any[] = AnyHelper.toAnyArray(posixApplication); 
		application.set_any(any); 
		jobDescription.setApplication(application); 
		jobDefinition.setJobDescription(jobDescription); 

		return jobDefinition; 
	}

}
